
var sleuth_dirname, sleuth_command_line, sleuth_language, ko;

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

// Arguments: ko, testPlanPrefs, obj{value:true/false, depending on how they leave}

const KO_ARG = 0;
const TEST_PLAN_NAME_ARG = 1;
const TEST_PLAN_ARG = 2;
const OBJ_RESULT_ARG = 3;

function onLoad() {
    ko = window.arguments[KO_ARG];
    var testPlanPref = window.arguments[TEST_PLAN_ARG];
    sleuth_dirname = document.getElementById('sleuth_dirname');
    sleuth_dirname.value = ko.sleuth.manager.dirFromPrefs(testPlanPref);
        
    sleuth_command_line = document.getElementById('sleuth_command_line');
    sleuth_command_line.value = testPlanPref.getStringPref('command_line');
    
    sleuth_language = document.getElementById('sleuth_language');
    sleuth_language.setAttribute("label",
                                 testPlanPref.getStringPref("language"));

    document.getElementById('currentTestPlanName').value = window.arguments[TEST_PLAN_NAME_ARG];
}

function editTestPlan_Accept() {
    var testPlanPref = window.arguments[TEST_PLAN_ARG];
    ko.sleuth.manager.setPrefToDir(testPlanPref, sleuth_dirname.value);
    testPlanPref.setStringPref('command_line', sleuth_command_line.value);
    testPlanPref.setStringPref("language",
                               sleuth_language.getAttribute("label"));
    window.arguments[OBJ_RESULT_ARG].value = true;
}

function editTestPlan_Cancel() {
    window.arguments[OBJ_RESULT_ARG].value = false;
}

function editTestPlan_Help() {
    //XXX write some help
    alert("Todo: provide help on modifying an exising test plan");
}

function doBrowseForDir() {
    var dir = ko.filepicker.getFolder(sleuth_dirname.value);
    if (dir) sleuth_dirname.value = dir;
};
